package aoc2015

import md5
import println
import readInput

/*
--- Day 4: The Ideal Stocking Stuffer ---
Santa needs help mining some AdventCoins (very similar to bitcoins) to use as gifts for all the economically forward-thinking little girls and boys.
To do this, he needs to find MD5 hashes which, in hexadecimal, start with at least five zeroes.  The input to the MD5 hash is some secret key (your puzzle input, given below) followed by a number in decimal. To mine AdventCoins, you must find Santa the lowest positive number (no leading zeroes: 1, 2, 3, ...) that produces such a hash.
For example:

If your secret key is abcdef, the answer is 609043, because the MD5 hash of abcdef609043 starts with five zeroes (000001dbbfa...), and it is the lowest such number to do so.
If your secret key is pqrstuv, the lowest number it combines with to make an MD5 hash starting with five zeroes is 1048970; that is, the MD5 hash of pqrstuv1048970 looks like 000006136ef....


*/
fun main() {

    val inlineTestInput = """
abcdef
"""

    fun part1(input: List<String>): Int {
        return IntRange(0, 10000000).first { (input.single() + it.toString()).md5().startsWith("00000") }
    }

    fun part2(input: List<String>): Int {
        return IntRange(0, 10000000).first { (input.single() + it.toString()).md5().startsWith("000000") }
    }

    // test if implementation meets criteria from the description, like:
    val testInput = inlineTestInput.trim().reader().readLines()
    //val testInput = readInput("aoc2015/Day04_test")
    val testInputPart1Result = part1(testInput)
    println("Part 1 Test: $testInputPart1Result")
    val testInputPart2Result = part2(testInput)
    println("Part 2 Test: $testInputPart2Result")
    check(testInputPart1Result == 609043)
    //check(testInputPart2Result == 0)

    val input = readInput("aoc2015/Day04")
    part1(input).println()
    part2(input).println()
}
